diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-close-test.cc ns-3.34/src/internet/test/tcp-close-test.cc
--- ns-3.33/src/internet/test/tcp-close-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-close-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -55,10 +55,14 @@
       m_recvClose = true;
   }
 
+  /**
+   * Called when a packet is dropped.
+   * \param ipH IP header
+   * \param tcpH TCP header
+   * \param pkt packet
+   */
   void PktDropped (const Ipv4Header &ipH, const TcpHeader& tcpH, Ptr<const Packet> pkt);
   
-  virtual void BytesAvailable (uint32_t size, SocketWho who);
-
 private:
   Ptr<TcpSeqErrorModel> m_errorModel; //!< The error model
   bool m_sendClose;                   //!< true when the sender has closed
@@ -108,18 +112,6 @@
 
   return m_errorModel;
 }
-  
-void TcpCloseWithLossTestCase::BytesAvailable(uint32_t size, SocketWho who)
-  {
-    if (m_synReceived && (who == SENDER))
-    {
-      this->GetSenderSocket()->Close();
-    }
-    else
-    {
-      m_synReceived = true;
-    }
-  }
 
 void
 TcpCloseWithLossTestCase::PktDropped (const Ipv4Header &ipH, const TcpHeader& tcpH, Ptr<const Packet> pkt)
@@ -154,8 +146,8 @@
 }
 
 /**
-  * Check if the TCP is correctly closing its state
-  */
+ * Check if the TCP is correctly closing its state
+ */
 class TcpTcpCloseTestSuite : public TestSuite
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-dctcp-test.cc ns-3.34/src/internet/test/tcp-dctcp-test.cc
--- ns-3.33/src/internet/test/tcp-dctcp-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-dctcp-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -21,8 +21,8 @@
 
 #include "ns3/ipv4.h"
 #include "ns3/ipv6.h"
-#include "../model/ipv4-end-point.h"
-#include "../model/ipv6-end-point.h"
+#include "ns3/ipv4-end-point.h"
+#include "ns3/ipv6-end-point.h"
 #include "tcp-general-test.h"
 #include "ns3/node.h"
 #include "ns3/log.h"
@@ -63,10 +63,10 @@
   void ConfigureEnvironment ();
 
 private:
-  uint32_t m_senderSent;
-  uint32_t m_receiverSent;
-  uint32_t m_senderReceived;
-  uint8_t m_testCase;
+  uint32_t m_senderSent;      //!< Number of packets sent by the sender
+  uint32_t m_receiverSent;    //!< Number of packets sent by the receiver
+  uint32_t m_senderReceived;  //!< Number of packets received by the sender
+  uint8_t m_testCase;         //!< Test type
 };
 
 TcpDctcpCodePointsTest::TcpDctcpCodePointsTest (uint8_t testCase, const std::string &desc)
@@ -197,8 +197,8 @@
    */
   static TypeId GetTypeId (void);
 
-  uint32_t m_dataPacketSent;
-  uint8_t m_testCase;
+  uint32_t m_dataPacketSent;  //!< Number of packets sent
+  uint8_t m_testCase;         //!< Test type
 
   TcpDctcpCongestedRouter ()
     : TcpSocketMsgBase ()
@@ -215,6 +215,10 @@
   {
   }
 
+  /**
+   * Set the test case type
+   * \param testCase test case type
+   */
   void SetTestCase (uint8_t testCase);
 protected:
   virtual uint32_t SendDataPacket (SequenceNumber32 seq, uint32_t maxSize, bool withAck);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-ecn-test.cc ns-3.34/src/internet/test/tcp-ecn-test.cc
--- ns-3.33/src/internet/test/tcp-ecn-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-ecn-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -25,8 +25,8 @@
 #include "ns3/ipv6-route.h"
 #include "ns3/ipv4-routing-protocol.h"
 #include "ns3/ipv6-routing-protocol.h"
-#include "../model/ipv4-end-point.h"
-#include "../model/ipv6-end-point.h"
+#include "ns3/ipv4-end-point.h"
+#include "ns3/ipv6-end-point.h"
 #include "tcp-general-test.h"
 #include "ns3/node.h"
 #include "ns3/log.h"
@@ -69,11 +69,11 @@
   void ConfigureProperties ();
 
 private:
-  uint32_t m_cwndChangeCount;
-  uint32_t m_senderSent;
-  uint32_t m_senderReceived;
-  uint32_t m_receiverReceived;
-  uint32_t m_testcase;
+  uint32_t m_cwndChangeCount;     //!< Number of times the congestion window did change
+  uint32_t m_senderSent;          //!< Number of segments sent by the sender
+  uint32_t m_senderReceived;      //!< Number of segments received by the sender
+  uint32_t m_receiverReceived;    //!< Number of segments received by the receiver
+  uint32_t m_testcase;            //!< Test case type
 };
 
 
@@ -98,8 +98,8 @@
    */
   static TypeId GetTypeId (void);
 
-  uint32_t m_dataPacketSent;
-  uint8_t m_testcase;
+  uint32_t m_dataPacketSent;  //!< Number of packets sent
+  uint8_t m_testcase;         //!< Test case type
 
   TcpSocketCongestedRouter ()
     : TcpSocketMsgBase ()
@@ -116,6 +116,10 @@
   {
   }
 
+  /**
+   * Set the test case type
+   * \param testCase Test case type
+   */
   void SetTestCase (uint8_t testCase);
 
 protected:
@@ -528,7 +532,7 @@
  *
  * \brief TCP ECN TestSuite
  */
-static class TcpEcnTestSuite : public TestSuite
+class TcpEcnTestSuite : public TestSuite
 {
 public:
   TcpEcnTestSuite () : TestSuite ("tcp-ecn-test", UNIT)
@@ -546,6 +550,8 @@
     AddTestCase (new TcpEcnTest (6, "Congestion Window Reduction Test :ECN capable sender and ECN capable receiver"),
                  TestCase::QUICK);
   }
-} g_tcpECNTestSuite;
+};
+
+static TcpEcnTestSuite g_tcpECNTestSuite; //!< static var for test initialization
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-general-test.cc ns-3.34/src/internet/test/tcp-general-test.cc
--- ns-3.33/src/internet/test/tcp-general-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-general-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -26,8 +26,8 @@
 #include "ns3/log.h"
 #include "ns3/queue.h"
 #include "ns3/tcp-l4-protocol.h"
-#include "../model/ipv4-end-point.h"
-#include "../model/ipv6-end-point.h"
+#include "ns3/ipv4-end-point.h"
+#include "ns3/ipv6-end-point.h"
 #include "ns3/tcp-header.h"
 #include "ns3/tcp-tx-buffer.h"
 #include "ns3/tcp-rx-buffer.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-general-test.h ns-3.34/src/internet/test/tcp-general-test.h
--- ns-3.33/src/internet/test/tcp-general-test.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-general-test.h	2021-07-14 10:31:06.000000000 -0700
@@ -619,7 +619,7 @@
    * \brief Enable or disable pacing of the initial window
    * 
    * \param who socket
-   * \param pacing Boolean to enable or disable pacing of initial window
+   * \param paceWindow Boolean to enable or disable pacing of initial window
    */
   void SetPaceInitialWindow (SocketWho who, bool paceWindow);
 
@@ -682,7 +682,7 @@
    *
    * \param recovery typeid of the recovery algorithm
    */
-  void SetRecoveryAlgorithm (TypeId reccovery) { m_recoveryTypeId = reccovery; }
+  void SetRecoveryAlgorithm (TypeId recovery) { m_recoveryTypeId = recovery; }
 
   /**
    * \brief MTU of the bottleneck link
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-linux-reno-test.cc ns-3.34/src/internet/test/tcp-linux-reno-test.cc
--- ns-3.33/src/internet/test/tcp-linux-reno-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-linux-reno-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -29,15 +29,21 @@
 
 NS_LOG_COMPONENT_DEFINE ("TcpLinuxRenoTest");
 
-// This unit test checks that the slow start and congestion avoidance
-// behavior matches Linux behavior as follows:
-// 1) in both slow start and congestion avoidance phases, presence or
-//    absence of delayed acks does not alter the window growth
-// 2) in congestion avoidance phase, the arithmetic for counting the number
-//    of segments acked and deciding when to increment the congestion window
-//    (i.e. following the Linux function tcp_cong_avoid_ai()) is followed.
-// Different segment sizes (524 bytes and 1500 bytes) are tested.
-
+/**
+ * \ingroup internet-test
+ * \ingroup tests
+ *
+ * This unit test checks that the slow start and congestion avoidance
+ * behavior matches Linux behavior as follows:
+ * 1) in both slow start and congestion avoidance phases, presence or
+ *    absence of delayed acks does not alter the window growth
+ * 2) in congestion avoidance phase, the arithmetic for counting the number
+ *    of segments acked and deciding when to increment the congestion window
+ *    (i.e. following the Linux function tcp_cong_avoid_ai()) is followed.
+ * Different segment sizes (524 bytes and 1500 bytes) are tested.
+ *
+ * This is the Slow Start test.
+ */
 class
 TcpLinuxRenoSSTest : public TcpGeneralTest
 {
@@ -181,6 +187,21 @@
   TcpGeneralTest::DoTeardown (); // call up to base class method to finish
 }
 
+/**
+ * \ingroup internet-test
+ * \ingroup tests
+ *
+ * This unit test checks that the slow start and congestion avoidance
+ * behavior matches Linux behavior as follows:
+ * 1) in both slow start and congestion avoidance phases, presence or
+ *    absence of delayed acks does not alter the window growth
+ * 2) in congestion avoidance phase, the arithmetic for counting the number
+ *    of segments acked and deciding when to increment the congestion window
+ *    (i.e. following the Linux function tcp_cong_avoid_ai()) is followed.
+ * Different segment sizes (524 bytes and 1500 bytes) are tested.
+ *
+ * This is the Congestion avoidance test.
+ */
 class
 TcpLinuxRenoCongAvoidTest : public TcpGeneralTest
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-loss-test.cc ns-3.34/src/internet/test/tcp-loss-test.cc
--- ns-3.33/src/internet/test/tcp-loss-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-loss-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -74,12 +74,12 @@
                        const TcpSocketState::TcpCongState_t newValue);
   Ptr<ErrorModel> CreateReceiverErrorModel ();
 private:
-  uint32_t m_firstLoss;
-  uint32_t m_secondLoss;
-  uint32_t m_sent {0};
-  uint32_t m_received {0};
-  uint32_t m_lastSegment {0};
-  std::list<int> m_expectedStates;
+  uint32_t m_firstLoss;             //!< First segment loss
+  uint32_t m_secondLoss;            //!< Second segment loss
+  uint32_t m_sent {0};              //!< Number of segments sent
+  uint32_t m_received {0};          //!< Number of segments received
+  uint32_t m_lastSegment {0};       //!< Last received segment
+  std::list<int> m_expectedStates;  //!< Expected TCP states
 };
 
 TcpLargeTransferLossTest::TcpLargeTransferLossTest (uint32_t firstLoss, uint32_t secondLoss, uint32_t lastSegment, const std::string &desc)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-lp-test.cc ns-3.34/src/internet/test/tcp-lp-test.cc
--- ns-3.33/src/internet/test/tcp-lp-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-lp-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -32,23 +32,34 @@
 NS_LOG_COMPONENT_DEFINE ("TcpLpTestSuite");
 
 /**
+ * \ingroup internet-test
+ * \ingroup tests
+ *
  * \brief Testing the behaviour common to New Reno
  */
 class TcpLpToNewReno : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param cWnd Congestion window size
+   * \param segmentSize Segment size
+   * \param segmentsAcked Segments acked
+   * \param ssThresh Slow start threshold
+   * \param rtt RTT
+   * \param name Test case name
+   */
   TcpLpToNewReno (uint32_t cWnd, uint32_t segmentSize,
-                  uint32_t segmentsAcked,uint32_t ssThresh, Time rtt, const std::string &name);
+                  uint32_t segmentsAcked, uint32_t ssThresh, Time rtt, const std::string &name);
 
 private:
   virtual void DoRun (void);
-  void ExecuteTest (void);
-  uint32_t m_cWnd;
-  uint32_t m_segmentSize;
-  uint32_t m_ssThresh;
-  uint32_t m_segmentsAcked;
-  Time m_rtt;
-  Ptr<TcpSocketState> m_state;
+  uint32_t m_cWnd;          //!< Congestion window size
+  uint32_t m_segmentSize;   //!< Segment size
+  uint32_t m_ssThresh;      //!< Slow start threshold
+  uint32_t m_segmentsAcked; //!< Segments acked
+  Time m_rtt;               //!< RTT
+  Ptr<TcpSocketState> m_state;  //!< TCP socket state
 };
 
 TcpLpToNewReno::TcpLpToNewReno (uint32_t cWnd, uint32_t segmentSize,
@@ -65,14 +76,6 @@
 void
 TcpLpToNewReno::DoRun ()
 {
-  Simulator::Schedule (Seconds (0.0), &TcpLpToNewReno::ExecuteTest, this);
-  Simulator::Run ();
-  Simulator::Destroy ();
-}
-
-void
-TcpLpToNewReno::ExecuteTest ()
-{
   m_state = CreateObject <TcpSocketState> ();
   m_state->m_cWnd = m_cWnd;
   m_state->m_ssThresh = m_ssThresh;
@@ -96,26 +99,38 @@
 
   NS_TEST_ASSERT_MSG_EQ (m_state->m_cWnd.Get (), state->m_cWnd.Get (),
                          "cWnd has not updated correctly");
+  Simulator::Run ();
+  Simulator::Destroy ();
 }
+
 /**
- * \brief Testing TcpLp when owd exceeds threshold
+ * \ingroup internet-test
+ * \ingroup tests
+ *
+ * \brief Testing TcpLp when cwd exceeds threshold
  */
-
 class TcpLpInferenceTest1 : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param cWnd Congestion window size
+   * \param segmentSize Segment size
+   * \param segmentsAcked Segments acked
+   * \param rtt RTT
+   * \param name Test case name
+   */
   TcpLpInferenceTest1 (uint32_t cWnd, uint32_t segmentSize,
                        uint32_t segmentsAcked, Time rtt, const std::string &name);
 
 private:
   virtual void DoRun (void);
-  void ExecuteTest (void);
 
-  uint32_t m_cWnd;
-  uint32_t m_segmentSize;
-  uint32_t m_segmentsAcked;
-  Time m_rtt;
-  Ptr<TcpSocketState> m_state;
+  uint32_t m_cWnd;          //!< Congestion window size
+  uint32_t m_segmentSize;   //!< Segment size
+  uint32_t m_segmentsAcked; //!< Segments acked
+  Time m_rtt;               //!< RTT
+  Ptr<TcpSocketState> m_state;  //!< TCP socket state
 };
 
 TcpLpInferenceTest1::TcpLpInferenceTest1 (uint32_t cWnd, uint32_t segmentSize,
@@ -131,14 +146,6 @@
 void
 TcpLpInferenceTest1::DoRun ()
 {
-  Simulator::Schedule (Seconds (0.0), &TcpLpInferenceTest1::ExecuteTest, this);
-  Simulator::Run ();
-  Simulator::Destroy ();
-}
-
-void
-TcpLpInferenceTest1::ExecuteTest ()
-{
   m_state = CreateObject <TcpSocketState> ();
   m_state->m_cWnd = m_cWnd;
   m_state->m_segmentSize = m_segmentSize;
@@ -157,26 +164,38 @@
   m_cWnd =  m_cWnd / 2;
   NS_TEST_ASSERT_MSG_EQ (m_state->m_cWnd.Get (), m_cWnd,
                          "cWnd has not updated correctly");
+  Simulator::Run ();
+  Simulator::Destroy ();
 }
 
 /**
+ * \ingroup internet-test
+ * \ingroup tests
+ *
  * \brief Testing TcpLp when it is inference phase
  */
 class TcpLpInferenceTest2 : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param cWnd Congestion window size
+   * \param segmentSize Segment size
+   * \param segmentsAcked Segments acked
+   * \param rtt RTT
+   * \param name Test case name
+   */
   TcpLpInferenceTest2 (uint32_t cWnd, uint32_t segmentSize,
                        uint32_t segmentsAcked, Time rtt, const std::string &name);
 
 private:
   virtual void DoRun (void);
-  void ExecuteTest (void);
 
-  uint32_t m_cWnd;
-  uint32_t m_segmentSize;
-  uint32_t m_segmentsAcked;
-  Time m_rtt;
-  Ptr<TcpSocketState> m_state;
+  uint32_t m_cWnd;          //!< Congestion window size
+  uint32_t m_segmentSize;   //!< Segment size
+  uint32_t m_segmentsAcked; //!< Segments acked
+  Time m_rtt;               //!< RTT
+  Ptr<TcpSocketState> m_state;  //!< TCP socket state
 };
 
 TcpLpInferenceTest2::TcpLpInferenceTest2 (uint32_t cWnd, uint32_t segmentSize,uint32_t segmentsAcked, Time rtt, const std::string &name)
@@ -191,14 +210,6 @@
 void
 TcpLpInferenceTest2::DoRun ()
 {
-  Simulator::Schedule (Seconds (0.0), &TcpLpInferenceTest2::ExecuteTest, this);
-  Simulator::Run ();
-  Simulator::Destroy ();
-}
-
-void
-TcpLpInferenceTest2::ExecuteTest ()
-{
   m_state = CreateObject <TcpSocketState> ();
   m_state->m_cWnd = m_cWnd;
   m_state->m_segmentSize = m_segmentSize;
@@ -221,19 +232,29 @@
 
   NS_TEST_ASSERT_MSG_EQ (m_state->m_cWnd.Get (), m_cWnd,
                          "cWnd has not updated correctly");
+  Simulator::Run ();
+  Simulator::Destroy ();
 }
 
-static class TcpLpTestSuite : public TestSuite
+/**
+ * \ingroup internet-test
+ * \ingroup tests
+ *
+ * Test the behaviour common to New Reno
+ */
+class TcpLpTestSuite : public TestSuite
 {
 public:
   TcpLpTestSuite () : TestSuite ("tcp-lp-test", UNIT)
   {
-    AddTestCase (new TcpLpToNewReno (4 * 1446, 1446,2, 2 * 1446, MilliSeconds (100), "LP falls to New Reno if the owd is within threshold"), TestCase::QUICK);
+    AddTestCase (new TcpLpToNewReno (4 * 1446, 1446, 2, 2 * 1446, MilliSeconds (100), "LP falls to New Reno if the cwd is within threshold"), TestCase::QUICK);
 
-    AddTestCase (new TcpLpInferenceTest1 (2 * 1446, 1446,2, MilliSeconds (100), "LP enters Inference phase when owd exceeds threshold for the first time"), TestCase::QUICK);
+    AddTestCase (new TcpLpInferenceTest1 (2 * 1446, 1446, 2, MilliSeconds (100), "LP enters Inference phase when cwd exceeds threshold for the first time"), TestCase::QUICK);
 
-    AddTestCase (new TcpLpInferenceTest2 (2 * 1446, 1446,2, MilliSeconds (100), "LP reduces cWnd to 1 if owd exceeds threshold in inference phase"), TestCase::QUICK);
+    AddTestCase (new TcpLpInferenceTest2 (2 * 1446, 1446, 2, MilliSeconds (100), "LP reduces cWnd to 1 if cwd exceeds threshold in inference phase"), TestCase::QUICK);
   }
-} g_tcplpTest;
+};
+
+static TcpLpTestSuite g_tcplpTest; //!< static var for test initialization
 
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-rate-ops-test.cc ns-3.34/src/internet/test/tcp-rate-ops-test.cc
--- ns-3.33/src/internet/test/tcp-rate-ops-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-rate-ops-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -44,31 +44,47 @@
 class TcpRateLinuxBasicTest : public TestCase
 {
 public:
+
+  /**
+   * Constructor
+   * \param cWnd Congestion window size
+   * \param tailSeq Tail sequence number
+   * \param nextTx Tx next sequence number
+   * \param testCase test case type
+   * \param testName test name
+   */
   TcpRateLinuxBasicTest (uint32_t cWnd, SequenceNumber32 tailSeq, SequenceNumber32 nextTx,
-                         uint32_t lostOut, uint32_t retransOut, uint32_t testCase,
-                         std::string testName);
+                         uint32_t testCase, std::string testName);
 
 private:
   virtual void DoRun (void);
 
+  /**
+   * Send an application packet
+   * \param skb the data to send
+   */
   void SendSkb (TcpTxItem * skb);
+  /**
+   * Deliver an application packet
+   * \param skb the data to deliver
+   */
   void SkbDelivered (TcpTxItem * skb);
 
-  TcpRateLinux              m_rateOps;
-  uint32_t                  m_cWnd;
-  uint32_t                  m_inFlight;
-  uint32_t                  m_segmentSize;
-  uint32_t                  m_delivered;
-  Time                      m_deliveredTime;
-  SequenceNumber32          m_tailSeq;
-  SequenceNumber32          m_nextTx;
-  uint32_t                  m_testCase;
-  std::vector <TcpTxItem *> m_skbs;
+  TcpRateLinux              m_rateOps;        //!< Rate information for TCP
+  uint32_t                  m_cWnd;           //!< Congestion window size
+  uint32_t                  m_inFlight;       //!< Number of packets in-flight
+  uint32_t                  m_segmentSize;    //!< Segment size
+  uint32_t                  m_delivered;      //!< Number of segments delivered
+  Time                      m_deliveredTime;  //!< Last time of a delivery
+  SequenceNumber32          m_tailSeq;        //!< Tail sequence number
+  SequenceNumber32          m_nextTx;         //!< Tx next sequence number
+  uint32_t                  m_testCase;       //!< Test case type
+  std::vector <TcpTxItem *> m_skbs;           //!< Application packets
 };
 
 TcpRateLinuxBasicTest::TcpRateLinuxBasicTest (uint32_t cWnd, SequenceNumber32 tailSeq,
-                                              SequenceNumber32 nextTx, uint32_t lostOut,
-                                              uint32_t retransOut, uint32_t testCase, std::string testName)
+                                              SequenceNumber32 nextTx,
+                                              uint32_t testCase, std::string testName)
   : TestCase (testName),
   m_cWnd (cWnd),
   m_inFlight (0),
@@ -548,8 +564,8 @@
   TcpRateOpsTestSuite ()
     : TestSuite ("tcp-rate-ops", UNIT)
   {
-    AddTestCase (new TcpRateLinuxBasicTest (1000, SequenceNumber32 (20), SequenceNumber32 (11), 1, 0, 0, "Testing SkbDelivered and SkbSent"), TestCase::QUICK);
-    AddTestCase (new TcpRateLinuxBasicTest (1000, SequenceNumber32 (11), SequenceNumber32 (11), 2, 0, 0, "Testing SkbDelivered and SkbSent with app limited data"), TestCase::QUICK);
+    AddTestCase (new TcpRateLinuxBasicTest (1000, SequenceNumber32 (20), SequenceNumber32 (11), 1, "Testing SkbDelivered and SkbSent"), TestCase::QUICK);
+    AddTestCase (new TcpRateLinuxBasicTest (1000, SequenceNumber32 (11), SequenceNumber32 (11), 2, "Testing SkbDelivered and SkbSent with app limited data"), TestCase::QUICK);
 
     std::vector<uint32_t> toDrop;
     toDrop.push_back (4001);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-syn-connection-failed-test.cc ns-3.34/src/internet/test/tcp-syn-connection-failed-test.cc
--- ns-3.33/src/internet/test/tcp-syn-connection-failed-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-syn-connection-failed-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -51,8 +51,8 @@
   virtual void DoRun ();
 
 private:
-  bool m_connectionFailed{false};
-  bool m_useEcn {false};
+  bool m_connectionFailed{false}; //!< Connection failure indicator
+  bool m_useEcn {false}; //!< Use ECN (true or false)
 };
 
 TcpSynConnectionFailedTest::TcpSynConnectionFailedTest (std::string desc, bool useEcn) : TestCase (desc), m_useEcn (useEcn)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-tx-buffer-test.cc ns-3.34/src/internet/test/tcp-tx-buffer-test.cc
--- ns-3.33/src/internet/test/tcp-tx-buffer-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-tx-buffer-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -53,7 +53,10 @@
   /** \brief Test the logic of merging items in GetTransmittedSegment()
    * which is triggered by CopyFromSequence()*/
   void TestMergeItemsWhenGetTransmittedSegment ();
-  /** \brief Callback to provide a value of receiver window */
+  /**
+   * \brief Callback to provide a value of receiver window
+   * \returns the receiver window size
+   */
   uint32_t GetRWnd (void) const;
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/wscript ns-3.34/src/internet/wscript
--- ns-3.33/src/internet/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -163,6 +163,7 @@
         'model/tcp-htcp.cc',
         'model/tcp-lp.cc',
         'model/tcp-dctcp.cc',
+        'model/tcp-bbr.cc',
         'model/tcp-rx-buffer.cc',
         'model/tcp-tx-buffer.cc',
         'model/tcp-tx-item.cc',
@@ -307,6 +308,7 @@
         'test/tcp-dctcp-test.cc',
         'test/tcp-syn-connection-failed-test.cc',
         'test/tcp-pacing-test.cc',
+        'test/tcp-bbr-test.cc',
         ]
     # Tests encapsulating example programs should be listed here
     if (bld.env['ENABLE_EXAMPLES']):
@@ -420,6 +422,8 @@
         'model/tcp-htcp.h',
         'model/tcp-lp.h',
         'model/tcp-dctcp.h',
+        'model/windowed-filter.h',
+        'model/tcp-bbr.h',
         'model/tcp-ledbat.h',
         'model/tcp-socket-base.h',
         'model/tcp-socket-state.h',
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/bindings/callbacks_list.py ns-3.34/src/internet-apps/bindings/callbacks_list.py
--- ns-3.33/src/internet-apps/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet-apps/bindings/callbacks_list.py	2021-07-14 10:31:06.000000000 -0700
@@ -7,5 +7,8 @@
     ['bool', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Socket>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ptr<ns3::Ipv6>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv6Header &', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ipv6L3Protocol::DropReason', 'ns3::Ptr<ns3::Ipv6>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv6Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
